//
//  LKView.m
//  demo4
//
//  Created by Mac on 16/8/24.
//  Copyright © 2016年 v. All rights reserved.
//

#import "LKView.h"
#define lkColor(r,g,b) [UIColor colorWithRed:(r)/255.0f green:(g)/255.0f blue:(b)/255.0f alpha:1.0]
@interface LKView() <UITextViewDelegate>
@property(nonatomic,assign)BOOL isClick;
@property(nonatomic,strong)UIImageView *origin;

@end
@implementation LKView

- (instancetype)initWithContent:(NSString *)content;
{
    self = [super init];
    if (self) {
        CGFloat x = arc4random_uniform(200);
        CGFloat y = arc4random_uniform(100) + 200;
        self.backgroundColor = [UIColor clearColor];
        
        //闪跃图标
        _origin= [[UIImageView alloc]init];
        _origin.frame = CGRectMake(0,5, 20, 20);
        _origin.userInteractionEnabled = YES;
        UITapGestureRecognizer *originClick = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(originClick)];
        [_origin addGestureRecognizer:originClick];
        [self addSubview:_origin];
        
        //跳动
        NSMutableArray *volatility = [[NSMutableArray alloc]init];
        for (int i = 1 ; i <=3; i ++) {
            NSString *fileName = [NSString stringWithFormat:@"%d",i];
            UIImage *image = [UIImage imageNamed:fileName];
            [volatility addObject:image];
        }
        _origin.animationImages = volatility;
        _origin.animationDuration = volatility.count * 0.1;
        _origin.animationRepeatCount =  INT16_MAX;
        [_origin startAnimating];
        
        //输入框
        _inputView= [[UITextView alloc]init];
        _inputView.delegate = self;
        _inputView.text = content;
        _inputView.alpha = 0.8;
        [_inputView sizeToFit];
        _inputView.frame = CGRectMake(CGRectGetMinX(_origin.frame)+30, 0, _inputView.frame.size.width+30, _inputView.frame.size.height);
        _inputView.scrollEnabled = NO;
        _inputView.textAlignment = NSTextAlignmentLeft;
        _inputView.layoutManager.allowsNonContiguousLayout = NO;
        _inputView.backgroundColor = lkColor(46, 38, 32);
        
        _inputView.textColor = [UIColor whiteColor];
        _inputView.font = [UIFont boldSystemFontOfSize:16];
        _inputView.contentOffset = CGPointMake(0,4);
        [self addSubview:_inputView];
        
        self.frame =CGRectMake(x,y , CGRectGetWidth(_origin.frame)+ CGRectGetWidth(_inputView.frame)+40, _inputView.frame.size.height);
        
        UILongPressGestureRecognizer *longGesture = [[UILongPressGestureRecognizer alloc]initWithTarget:self action:@selector(longPress:)];
        longGesture.allowableMovement = 10;
        [self addGestureRecognizer:longGesture];
    }
    return self;
}

- (void)longPress:(UILongPressGestureRecognizer *)longGress {
    if (longGress.state == UIGestureRecognizerStateBegan) {
        if ([self.delegate respondsToSelector:@selector(lkViewLongGestureWith:)]) {
            [self.delegate lkViewLongGestureWith:self];
        }
    }
}

-(void)originClick{
    _isClick = !_isClick;
    if (_isClick) {
        [UIView animateWithDuration:0.25 animations:^{
            self.origin.transform = CGAffineTransformTranslate(self.origin.transform, CGRectGetMaxX(self.inputView.frame) + 10, 0);
        }];
    }else{
        [UIView animateWithDuration:0.25 animations:^{
          self.origin.transform = CGAffineTransformIdentity;
        }];
    }
}

- (void) textViewDidChange:(UITextView *)textView{
    CGSize size =
    [textView sizeThatFits:CGSizeMake([UIScreen mainScreen].bounds.size.width, 30)];
    
    CGRect frame = textView.frame;
    frame.size.height = size.height;
    frame.size.width = size.width;

    textView.frame = frame;
    
    CGRect selfFrame = self.frame;
    selfFrame.size.width = CGRectGetWidth(_origin.frame)+ CGRectGetWidth(_inputView.frame)+40;
    selfFrame.size.height = _inputView.frame.size.height;
    self.frame = selfFrame;
}

- (void)touchesMoved:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    if ([self.delegate respondsToSelector:@selector(lkViewClickWith:)]) {
        [self.delegate lkViewClickWith:self];
    }
}



@end
