//
//  ViewController.m
//  标签
//
//  Created by Mac on 16/9/28.
//  Copyright © 2016年 v. All rights reserved.
//

#import "ViewController.h"
#import "LKView.h"
#define lkScreenWidth [UIScreen mainScreen].bounds.size.width
#define lkScreenheight [UIScreen mainScreen].bounds.size.height
#define lkColor(r,g,b) [UIColor colorWithRed:(r)/255.0f green:(g)/255.0f blue:(b)/255.0f alpha:1.0]
@interface ViewController ()<LKViewDelegate>

//添加按钮
@property(nonatomic,strong)UIButton *addbutton;
//图片
@property(nonatomic,strong)UIImageView *imgView;
//阴影
@property(nonatomic,strong)UIView *shadow;

//添加标签view
@property(nonatomic,strong)UIView *whiteView;
//内容
@property(nonatomic,strong)UITextField *content;

//标签
@property(nonatomic,strong)LKView *lkView;

//编辑view
@property(nonatomic,strong)UIView *editorView;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = @"编辑";
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc]initWithTitle:@"保存" style:UIBarButtonItemStylePlain target:self action:@selector(save)];
    self.view.backgroundColor  = [UIColor lightGrayColor];
    self.navigationController.automaticallyAdjustsScrollViewInsets = NO;
    [self addSubView];
}

- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.view endEditing:YES];
    [self.editorView removeFromSuperview];
}

- (void) save{
   UIImage *image = [self screenshotWithRect:CGRectMake(CGRectGetMinX(self.imgView.frame), CGRectGetMinY(self.imgView.frame), CGRectGetWidth(self.imgView.frame), CGRectGetHeight(self.imgView.frame))];
    
     UIImageWriteToSavedPhotosAlbum(image,self,@selector(image:didFinishSavingWithError:contextInfo:),NULL);
}

-(void)image:(UIImage*)image didFinishSavingWithError:(NSError*)error contextInfo:(void*)contextInfo
{
    if(!error){
    }else{
    }
}

- (UIImage *)screenshotWithRect:(CGRect)rect;
{
    UIGraphicsBeginImageContextWithOptions(self.view.frame.size, NO, [UIScreen mainScreen].scale);
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    if (context == NULL)
    {
        return nil;
    }
    CGContextSaveGState(context);
    CGContextTranslateCTM(context, -rect.origin.x, -rect.origin.y);

    CGContextRestoreGState(context);
    
    UIImage *image = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return image;
}

- (void) addSubView{
    _addbutton = [[UIButton alloc]init];
    [_addbutton setBackgroundColor:[UIColor blackColor]];
    _addbutton.frame = CGRectMake((lkScreenWidth-50)/2, lkScreenheight - 50 - 10, 40, 40);
    _addbutton.layer.cornerRadius = 20;
    [_addbutton addTarget:self action:@selector(addClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_addbutton];
    
    _imgView = [[UIImageView alloc]init];
    _imgView.userInteractionEnabled = YES;
    _imgView.frame = CGRectMake(0, (lkScreenheight-400-_addbutton.frame.size.height)/2, lkScreenWidth, 300);
    _imgView.image = [UIImage imageNamed:@"B1366A26A3BE5015F8EAD2C0F7460271"];
    [self.view addSubview:_imgView];
    
    // 捏合手势
    UIPinchGestureRecognizer *pinchGestureRecognizer = [[UIPinchGestureRecognizer alloc] initWithTarget:self action:@selector(pinch:)];
    [self.view addGestureRecognizer:pinchGestureRecognizer];
}

- (void)pinch:(UIPinchGestureRecognizer *)pinch{
    CGFloat scale = pinch.scale;
    self.imgView.transform = CGAffineTransformScale(self.imgView.transform, scale, scale);
    pinch.scale = 1.0;
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3.0 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [UIView animateWithDuration:1.0 animations:^{
            self.imgView.transform = CGAffineTransformIdentity;
        }];
    });
}

//添加
- (void) addClick{
    self.shadow = [[UIView alloc]init];
    self.shadow.frame = CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width,  [UIScreen mainScreen].bounds.size.height);
    self.shadow.backgroundColor = [UIColor blackColor];
    self.shadow.alpha  =0.5;
    [self.shadow addGestureRecognizer:[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(shadowClick)]];
    [self.view addSubview:self.shadow];
    
     _whiteView = [[UIView alloc]init];
    _whiteView.backgroundColor = [UIColor whiteColor];
    _whiteView.frame  = CGRectMake(0,0, 250, 150);
    _whiteView.center = self.imgView.center;
    _whiteView.layer.cornerRadius = 5;
    [self.view addSubview:_whiteView];
    
    UIButton *fixedButton = [[UIButton alloc]init];
    [fixedButton setBackgroundImage:[UIImage imageNamed:@"Snip20160928_10"] forState:UIControlStateNormal];
        [fixedButton setBackgroundImage:[UIImage imageNamed:@"Snip20160928_12"] forState:UIControlStateHighlighted];
    [fixedButton setTitle:@"确定" forState:UIControlStateNormal];
    fixedButton.frame = CGRectMake(10, CGRectGetHeight(_whiteView.frame)- 54, 230, 44);
    fixedButton.layer.cornerRadius = 5;
    [fixedButton addTarget:self action:@selector(fixedClick) forControlEvents:UIControlEventTouchUpInside];
    [_whiteView addSubview:fixedButton];
    
    _content = [[UITextField alloc]init];
    _content.borderStyle = UITextBorderStyleRoundedRect;
    _content.frame = CGRectMake(10, 10, 230, CGRectGetHeight(_whiteView.frame) - CGRectGetHeight(fixedButton.frame) - 30);
    _content.placeholder = @"输入标签";
    [_whiteView addSubview:_content];
    
    
    self.addbutton.hidden = YES;
}

//阴影点击
- (void) shadowClick{
    [self.shadow removeFromSuperview];
    [self.whiteView removeFromSuperview];
    self.addbutton.hidden = NO;
}

//确定
- (void) fixedClick{
    if ([_content.text isEqualToString:@""]) {
        NSLog(@"请输入内容");
        return;
    }
    [self.view endEditing:YES];
    [self shadowClick];
    
    LKView *view = [[LKView alloc]initWithContent:self.content.text];
    view.delegate = self;
    [self.view addSubview:view];
}

#pragma mark  - LKViewDelegate
- (void)lkViewClickWith:(LKView *)sender{
    self.lkView  = sender;
}

- (void)lkViewLongGestureWith:(LKView *)sneder{
    self.lkView = sneder;
    _editorView = [[UIView alloc]initWithFrame:CGRectMake(sneder.frame.origin.x+10, CGRectGetMinY(sneder.frame) - 54, 100, 44)];
    _editorView.backgroundColor = [UIColor blackColor];
    [self.view addSubview:_editorView];
    
    UIButton *editorButton = [[UIButton alloc]init];
    editorButton.frame = CGRectMake(0, 0, CGRectGetWidth(_editorView.frame)/2, CGRectGetHeight(_editorView.frame));
    [editorButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [editorButton setTitleColor:[UIColor lightGrayColor] forState:UIControlStateHighlighted];
    [editorButton setTitle:@"编辑" forState:UIControlStateNormal];
    [editorButton addTarget:self action:@selector(editorClick) forControlEvents:UIControlEventTouchUpInside];
    [_editorView addSubview:editorButton];
    
    UIButton *deleteButton = [[UIButton alloc]init];
    deleteButton.frame = CGRectMake(CGRectGetMaxX(editorButton.frame),0 , CGRectGetWidth(_editorView.frame)/2, CGRectGetHeight(_editorView.frame));
    [deleteButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [deleteButton setTitleColor:[UIColor lightGrayColor] forState:UIControlStateHighlighted];
    [deleteButton setTitle:@"删除" forState:UIControlStateNormal];
    [deleteButton addTarget:self action:@selector(deleteClick) forControlEvents:UIControlEventTouchUpInside];
    [_editorView addSubview:deleteButton];
    
}

- (void)editorClick{
    [self.lkView.inputView becomeFirstResponder];
    [self.editorView removeFromSuperview];
}

- (void)deleteClick{
    [self.lkView removeFromSuperview];
    [self.editorView removeFromSuperview];
}


-(void)touchesMoved:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    UITouch *aTouch = [touches anyObject];
    //获取当前触摸操作的位置坐标
    CGPoint loc = [aTouch locationInView:self.imgView];
    //获取上一个触摸点的位置坐标
    CGPoint prevloc = [aTouch previousLocationInView:self.imgView];
    CGRect myFrame = self.lkView.frame;
    //改变View的x、y坐标值
    float deltaX = loc.x - prevloc.x;
    float deltaY = loc.y - prevloc.y;
    myFrame.origin.x += deltaX;
    myFrame.origin.y += deltaY;
    //重新设置View的显示位置
    [self.lkView setFrame:myFrame];
}

@end
